unit BCMAParameters;
{
================================================================================
*	File:  BCMAParameters.PAS
*
*	Application:  Bar Code Medication Administration - Site Parameters
*	Revision:     $Revision: 31 $  $Modtime: 1/16/02 6:09p $
*	Description:  This form provides access to the server side BCMA Site
*               Parameters for the application.
*
*	Notes:
*
*
================================================================================
*	$Archive: /BCMA GUI V2/BCMA Parameters/PSB_2_0/BCMAParameters.pas $
}

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  Trpcb, MFunStr, StdCtrls, ExtCtrls, ComCtrls, Menus, BCMA_ParObjects,
  BCMA_Util, Buttons, ehshelprouter, ehsbase, ehswhatsthis;

type
  TListNames = (lnPRN, lnHeld, lnRefused, lnInjection);

  TfrmBCMAParameters = class(TForm)
    menu: TMainMenu;
    menuHelp: TMenuItem;
    menuHelpAbout: TMenuItem;
    menuFile: TMenuItem;
    menuFileOpen: TMenuItem;
    menuFileClose: TMenuItem;
    N1: TMenuItem;
    menuFileExit: TMenuItem;
    Panel3: TPanel;
    mnLister: TPopupMenu;
    mnListAdd: TMenuItem;
    mnListEdit: TMenuItem;
    mnDeleteItem: TMenuItem;
    menuHelpContents: TMenuItem;
    menuHelpIndex: TMenuItem;
    N2: TMenuItem;
    gbBCMA: TGroupBox;
    lblBlack: TLabel;
    lblSilver: TLabel;
    PageControl1: TPageControl;
    tsFacility: TTabSheet;
    GroupBox5: TGroupBox;
    Label6: TLabel;
    Label5: TLabel;
    Label4: TLabel;
    Label3: TLabel;
    Label2: TLabel;
    Label1: TLabel;
    edtAddressZip: TEdit;
    edtAddressState: TEdit;
    edtAddressCity: TEdit;
    edtAddress2: TEdit;
    edtAddress1: TEdit;
    edtFacName: TEdit;
    GroupBox6: TGroupBox;
    Label21: TLabel;
    cbxOnLine: TCheckBox;
    tsAnswerList: TTabSheet;
    GroupBox3: TGroupBox;
    Label7: TLabel;
    cbxListName: TComboBox;
    btnSaveList: TButton;
    tbshtIVParameters: TTabSheet;
    pnlIVParLeft: TPanel;
    GroupBox1: TGroupBox;
    GroupBox2: TGroupBox;
    pnlIVParRight: TPanel;
    grpIVPrompts: TGroupBox;
    cbxIVParWard: TComboBox;
    Label25: TLabel;
    Label26: TLabel;
    cbxIVParType: TComboBox;
    btnIVParCancel: TButton;
    btnIVParOK: TButton;
    Label27: TLabel;
    Label28: TLabel;
    Label29: TLabel;
    Label30: TLabel;
    Label31: TLabel;
    Label32: TLabel;
    Label33: TLabel;
    Label34: TLabel;
    Label35: TLabel;
    Label37: TLabel;
    Label38: TLabel;
    Label39: TLabel;
    Label40: TLabel;
    Label41: TLabel;
    ComboBox1: TComboBox;
    ComboBox2: TComboBox;
    ComboBox3: TComboBox;
    ComboBox4: TComboBox;
    ComboBox5: TComboBox;
    ComboBox6: TComboBox;
    ComboBox7: TComboBox;
    ComboBox8: TComboBox;
    ComboBox9: TComboBox;
    ComboBox10: TComboBox;
    ComboBox11: TComboBox;
    ComboBox12: TComboBox;
    ComboBox13: TComboBox;
    ComboBox14: TComboBox;
    ComboBox15: TComboBox;
    Label42: TLabel;
    lblDivision: TLabel;
    btnReset: TButton;
    lvwDefAnswer: TListView;
    Memo1: TMemo;
    tbshtIHS: TTabSheet;
    lbledtPatIdLabel: TLabeledEdit;
    lbledtDivPatIdLabel: TLabeledEdit;
    lbledtSysPatIdLabel: TLabeledEdit;
    btnIHSOK: TButton;
    tsParameters: TTabSheet;
    Panel2: TPanel;
    gbxHFS: TGroupBox;
    Label13: TLabel;
    edtHFSBackup: TEdit;
    gbxMailGroups: TGroupBox;
    Label15: TLabel;
    Label16: TLabel;
    lblUnabletoScan: TLabel;
    edtMGDLError: TEdit;
    edtMGMissingDose: TEdit;
    edtMgUnknown: TLabeledEdit;
    edtMGMSF: TEdit;
    grpBarCodeOptions: TGroupBox;
    lblDefaultBarCodeFormat: TLabel;
    lblDefaultBarCodePrefix: TLabel;
    cbxBCFormat: TComboBox;
    edtBCPrefix: TEdit;
    chkRobotRX: TCheckBox;
    GroupBox4: TGroupBox;
    Label14: TLabel;
    edtMedHistDaysBack: TEdit;
    cbxRptInclComm: TCheckBox;
    grpFiveRights: TGroupBox;
    chk5UnitDose: TCheckBox;
    chk5IV: TCheckBox;
    Panel5: TPanel;
    gbxVDL: TGroupBox;
    Label18: TLabel;
    Label19: TLabel;
    cmbxStartTime: TComboBox;
    cmbxStopTime: TComboBox;
    gbxAdministration: TGroupBox;
    cbxESig: TCheckBox;
    chkMultiAdmin: TCheckBox;
    grpMiscOptions: TGroupBox;
    lblPatientTransfer: TLabel;
    Label36: TLabel;
    lblPRNDoc: TLabel;
    Label23: TLabel;
    Label24: TLabel;
    Label8: TLabel;
    edtPatientTransfer: TEdit;
    edtTimeout: TEdit;
    chkCPRSMedOrder: TCheckBox;
    edtPRNDoc: TEdit;
    cbxPatchDuration: TComboBox;
    edtMaximumServerClockVariance: TEdit;
    edtMaxDateRange: TEdit;
    grpIncludeScheduleTypes: TGroupBox;
    cbxCont: TCheckBox;
    cbxPRN: TCheckBox;
    cbxOneTime: TCheckBox;
    cbxOnCall: TCheckBox;
    grpAllowableTime: TGroupBox;
    Label9: TLabel;
    Label10: TLabel;
    Label11: TLabel;
    cmbxMinBefore: TComboBox;
    cmbxMinAfter: TComboBox;
    cmbxPRNEffect: TComboBox;
    btnIHSCancel: TButton;
    HelpRouter1: THelpRouter;
    WhatsThis1: TWhatsThis;
    lbledtAllPatIdLabel: TLabeledEdit;
    procedure edtMaxDateRangeExit(Sender: TObject);
    procedure chk5IVClick(Sender: TObject);
    procedure chk5UnitDoseClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    (*
      Sets the application OnExcept handler to be method ExceptionHandler.
      Checks to make sure the user has Manager access.  Displays a warning
      message that all changes are immediate.  Initializes variables.
    *)

    procedure FormCloseQuery(Sender: TObject; var CanClose: Boolean);
    (*
      Calls method menuFileCloseClick.
    *)

    procedure menuFileOpenClick(Sender: TObject);
    (*
      Calls method menuFileCloseClick.  Prompts the user for a division number.
      Uses RPC 'PSB PARAMETER' to retrieve name and address data for the
      entered division.  Uses method GetParameter to download the current
      values of the site parameters.  Fills the list of lists combobox on the
      Answer Lists tabsheet.
    *)

    procedure menuFileCloseClick(Sender: TObject);
    (*
      Sets the PageControl visibilty to False.  Reinitializes variables.
    *)

    procedure menuFileExitClick(Sender: TObject);
    (*
      Calls method menuFileCloseClick and then terminates the application.
    *)

    procedure mnListerPopup(Sender: TObject);
    (*
      Initializes the AnswerList ListBox's popupmenu.
    *)

    procedure cbxOnLineClick(Sender: TObject);
    (*
      Calls method SetParameter to set the ONLINE parameter 'on' or 'off'.  If
      If the new value is 'off', a warning message is displayed and a chance
      to cancel offered.
    *)

    procedure cbxESigClick(Sender: TObject);
    (*
      Calls method SetParameter to set the 'Esig Required' parameter 'on' or
      'off'.
    *)

    procedure cbxContClick(Sender: TObject);
    (*
      Calls method SetParameter to set the 'Include Continuous Schedule Type'
      parameter on or off.  This is a default setting for new BCMA users.
    *)

    procedure cbxPRNClick(Sender: TObject);
    (*
      Calls method SetParameter to set the 'Include PRN Schedule Type'
      parameter on or off.  This is a default setting for new BCMA users.
    *)

    procedure cbxOneTimeClick(Sender: TObject);
    (*
      Calls method SetParameter to set the 'Include One-Time Schedule Type'
      parameter on or off.  This is a default setting for new BCMA users.
    *)

    procedure cbxOnCallClick(Sender: TObject);
    (*
      Calls method SetParameter to set the 'Include On-Call Schedule Type'
      parameter on or off.  This is a default setting for new BCMA users.
    *)

    procedure cmbxStartTimeClick(Sender: TObject);
    (*
      Calls method SetParameter to set the 'VDL StartTime' parameter.  This is
      the decrement from Now for the Virtual Due List display.
    *)

    procedure cmbxStopTimeClick(Sender: TObject);
    (*
      Calls method SetParameter to set the 'VDL StopTime' parameter.  This is
      the increment from Now for the Virtual Due List display.
    *)

    procedure cmbxMinBeforeClick(Sender: TObject);
    (*
      Calls method SetParameter to set the 'Allowable Time Limit Before the
      Scheduled Administration Time' parameter.
    *)

    procedure cmbxMinAfterClick(Sender: TObject);
    (*
      Calls method SetParameter to set the 'Allowable Time Limit After the
      Scheduled Administration Time' parameter.
    *)

    procedure cmbxPRNEffectClick(Sender: TObject);
    (*
      Calls method SetParameter to set the 'Allowable Time Limit for PRN
      Effectiveness' parameter.
    *)

    procedure edtEnter(Sender: TObject);
    (*
      This method handles the OnEnter events for all of the TEdit fields on the
      form.  It sets the tag property of the sender to 0.
    *)

    procedure edtChange(Sender: TObject);
    (*
      This method handles the OnChange events for all of the TEdit fields on
      the form.  It sets the tag property of the sender to 1.
    *)

    //procedure edtHFSScratchExit(Sender: TObject);   bjr 5/12/10 for BCMA00000425
    (*
      This method handles the OnExit event for this TEdit field. If the tag
      property is not 0, the SetParameter method is used to send the changes
      to the server.  If SetParameter is not successful, GetParameter is used
      to restore the server value.  Finally, the tag property is set back to 0.
    *)

    procedure edtHFSBackupExit(Sender: TObject);
    (*
      This method handles the OnExit event for this TEdit field. If the tag
      property is not 0, the SetParameter method is used to send the changes
      to the server.  If SetParameter is not successful, GetParameter is used
      to restore the server value.  Finally, the tag property is set back to 0.
    *)

    procedure edtMGSysErrorExit(Sender: TObject);
    (*
      This method handles the OnExit event for this TEdit field. If the tag
      property is not 0, the SetParameter method is used to send the changes
      to the server.  If SetParameter is not successful, GetParameter is used
      to restore the server value.  Finally, the tag property is set back to 0.
    *)

    procedure edtMGDLErrorExit(Sender: TObject);
    (*
      This method handles the OnExit event for this TEdit field. If the tag
      property is not 0, the SetParameter method is used to send the changes
      to the server.  If SetParameter is not successful, GetParameter is used
      to restore the server value.  Finally, the tag property is set back to 0.
    *)

    procedure edtMGMissingDoseExit(Sender: TObject);
    (*
      This method handles the OnExit event for this TEdit field. If the tag
      property is not 0, the SetParameter method is used to send the changes
      to the server.  If SetParameter is not successful, GetParameter is used
      to restore the server value.  Finally, the tag property is set back to 0.
    *)

    procedure edtMaximumServerClockVarianceExit(Sender: TObject);
    (*
      This method handles the OnExit event for this TEdit field. If the tag
      property is not 0, the SetParameter method is used to send the changes
      to the server.  If SetParameter is not successful, GetParameter is used
      to restore the server value.  Finally, the tag property is set back to 0.
    *)

    procedure mnListAddClick(Sender: TObject);
    (*
      Prompts for a new item to add to the currently displayed list.
      Sets btnSaveList.Enabled = True.
    *)

    procedure mnDeleteItemClick(Sender: TObject);
    (*
      Deletes the currently highlighted item from the displayed list.
      Sets btnSaveList.Enabled = True.
    *)

    procedure mnListEditClick(Sender: TObject);
    (*
      Presents the currently highlighted item in an InputQuery dialog for
      editing.  Replaces the results into the displayed list.
      Sets btnSaveList.Enabled = True.
    *)

    procedure btnSaveListClick(Sender: TObject);
    (*
      Uses RPC 'PSB PARAMETER' to save the edited list onto the server.
      Sets btnSaveList.Enabled = False.
    *)

    procedure menuHelpAboutClick(Sender: TObject);
    (*
      Displays the About dialog.
    *)

    procedure menuHelpContentsClick(Sender: TObject);
    (*
      Opens the application help file.
    *)

    procedure PageControl1Change(Sender: TObject);
    (*
      Sets the initial focus when changing tabsheets.
    *)

    procedure cbxListNameChange(Sender: TObject);
    {
      Uses RPC 'PSB PARAMETER' to retrieve selection lists from the server.
      The list downloaded depends on the item selected in the ListName
      combobox.  The downloaded list is displayed in the lvwDefAnswer
      listview, ready for editing.
    }

    procedure cbxIVParWardDrawItem(Control: TWinControl; Index: Integer;
      Rect: TRect; State: TOwnerDrawState);
    {
    }

    procedure cbxIVParWardChange(Sender: TObject);
    {
    }

    procedure cbxIVParTypeDrawItem(Control: TWinControl; Index: Integer;
      Rect: TRect; State: TOwnerDrawState);
    {
    }

    procedure cbxIVParTypeChange(Sender: TObject);
    {
    }

    procedure cbxBCFormatClick(Sender: TObject);
    {
    }

    procedure edtBCPrefixExit(Sender: TObject);
    {
    }

    procedure chkRobotRXClick(Sender: TObject);
    {
    }

    procedure chkMultiAdminClick(Sender: TObject);
    {
    }

    procedure edtPatientTransferExit(Sender: TObject);
    {
    }

    procedure edtPRNDocExit(Sender: TObject);
    {
    }

    procedure btnIVParOKClick(Sender: TObject);
    {
    }

    procedure btnResetClick(Sender: TObject);
    {
    }

    procedure btnIVParCancelClick(Sender: TObject);
    {
    }

    procedure ComboBox1Change(Sender: TObject);
    {
    }

    procedure edtTimeoutExit(Sender: TObject);
    {
    }

    procedure chkCPRSMedOrderClick(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure cbxListNameSelect(Sender: TObject);
    procedure PageControl1Changing(Sender: TObject;
      var AllowChange: Boolean);
    procedure edtMedHistDaysBackChange(Sender: TObject);
    procedure edtMedHistDaysBackEnter(Sender: TObject);
    procedure edtMedHistDaysBackExit(Sender: TObject);
    procedure cbxRptInclCommClick(Sender: TObject);
    procedure cbxPatchDurationClick(Sender: TObject);
    procedure edtMgUnknownExit(Sender: TObject);
    procedure edtMGMSFExit(Sender: TObject);
    procedure lbledtPatIdLabelExit(Sender: TObject);
    procedure btnIHSOKClick(Sender: TObject);
    procedure btnIHSCancelClick(Sender: TObject);
    procedure menuHelpIndexClick(Sender: TObject);
    procedure WhatsThis1Popup(Sender, HelpItem: TObject; HContext: THelpContext;
      X, Y: Integer; var DoPopup: Boolean);
    {
    Presents the user with a warning if changing default lists without
    saving current changes.

    Call the OnChange Event for cbxListName.
    }

  private
    { Private declarations }
    UpdateMode: Boolean; // set to false during form load.

    function GetParameter(Parameter: string; UpArrowPiece: Integer): string;
    (*
      Uses RPC 'PSB PARAMETER' to get a Site Parameter from the server.
      Returns parameter string if successful.
    *)

    function GetParameterLevel(Parameter: string; Level: string; UpArrowPiece:
      Integer): string;
    (*
      Uses RPC 'PSB PARAMETER' to get a Site Parameter from the server.
      Level should contain either 'DIV' or 'SYS' to specify the level of the
      parameter being retrieved.
      Returns parameter string if successful.
    *)

    function SetParameter(Parameter: string; newValue: string): Boolean;
    (*
      Uses RPC 'PSB PARAMETER' to save a Site Parameter to the server.
      Returns True if successful.
    *)

    function LeaveTsAnswerList: Boolean;
    (*  determine if the current list has been saved. Warn user and return users
    response.

    Returns   TRUE if ok to leave page
              FALSE if NOT
    *)

    procedure ExceptionHandler(Sender: TObject; E: Exception);
    (*
      Handles all OnException events by calling the global BCMA exception
      handler, BCMAExceptionHandler.
    *)

    procedure GetWardList();
    procedure GetIVPar(Value: string);
    procedure ClearAll();
    procedure PutIVPar();
    procedure LoadIHS;
    procedure SaveIHS;
  public
    { Public declarations }
  end;

var
  frmBCMAParameters: TfrmBCMAParameters;

  currentListName,
    Division,
    DivisionIENS,
    SelectedWardIEN: string;
  currentListIndex: integer;
  BCMA_WardList: TBCMA_WardList;
  IVTypeList: TStringList;
  LeaveTsDefaultList_Warning: boolean = true;

implementation

{$R *.DFM}

uses
  BCMA_Startup, Debug, FAboutDlg, InputQry, VHA_Objects;

function ShowApplicationAndFocusOK(anApplication: TApplication):
  boolean;
var
  j: integer;
  Stat2: set of (sWinVisForm, sWinVisApp, sIconized);
  hFGWnd: THandle;
begin
  Stat2 := []; {sWinVisForm,sWinVisApp,sIconized}

  if IsWindowVisible(anApplication.MainForm.Handle) then
    Stat2 := Stat2 + [sWinVisForm];

  if IsWindowVisible(anApplication.Handle) then
    Stat2 := Stat2 + [sWinVisApp];

  if IsIconic(anApplication.Handle) then
    Stat2 := Stat2 + [sIconized];

  Result := true;
  if sIconized in Stat2 then
  begin {A}
    j := SendMessage(anApplication.Handle, WM_SYSCOMMAND, SC_RESTORE, 0);
    Result := j <> 0;
  end;
  if Stat2 * [sWinVisForm, sIconized] = [] then
  begin {S}
    anApplication.MainForm.Show;
  end;
  if (Stat2 * [sWinVisForm, sIconized] <> []) or
    (sWinVisApp in Stat2) then
  begin {G}
    hFGWnd := GetForegroundWindow;
    try
      AttachThreadInput(
        GetWindowThreadProcessId(hFGWnd, nil),
        GetCurrentThreadId, True);
      Result := SetForegroundWindow(anApplication.Handle);
    finally
      AttachThreadInput(
        GetWindowThreadProcessId(hFGWnd, nil),
        GetCurrentThreadId, False);
    end;
  end;
end;

function StrRight(str: string; ByteRead: integer): string;
begin
  if ByteRead > Length(str) then
    Result := str
  else
    Result := Copy(str, Length(str) - ByteRead + 1, ByteRead);
end;

procedure TfrmBCMAParameters.btnIVParCancelClick(Sender: TObject);
begin
  cbxIVParWardChange(cbxIVParWard);
end;

procedure TfrmBCMAParameters.btnIHSCancelClick(Sender: TObject);
begin
  LoadIHS;
end;

procedure TfrmBCMAParameters.btnIHSOKClick(Sender: TObject);
begin
  lbledtPatIdLabel.Text := AnsiUpperCase(lbledtPatIdLabel.Text);
  SaveIHS;
end;

procedure TfrmBCMAParameters.ExceptionHandler(Sender: TObject; E: Exception);
begin
  BCMAExceptionHandler(Sender, E); (* Uses the BCMA Global exception handler. *)
end;

procedure TfrmBCMAParameters.FormCreate(Sender: TObject);
begin
  ForceForegroundWindow(handle);
  Caption := Application.Title;
  application.OnException := ExceptionHandler;

  UserIsLoggedOn := False;

  if (BCMA_User.IsManager) then
  begin
    MessageDlg('Updates to parameters are immediate!' + #13 + #13 +
      'Use this program with extreme care!',
      mtWarning, [mbOK], 0);

    UpdateMode := False;

    gbBCMA.Top := (self.Height - gbBCMA.Height - 80) div 2;
    gbBCMA.Left := (self.Width - gbBCMA.Width) div 2;
    lblDivision.Top := (gbBCMA.Top + gbBCMA.Height + 20);
    lblDivision.Left := (Self.Width - lblDivision.Width) div 2;

    UserIsLoggedOn := True;
    BCMA_WardList := TBCMA_WardList.Create(BCMA_Broker);
    lblDivision.Caption := 'You are currently logged on to Division: ' +
      BCMA_User.DivisionIEN;
    cbxIVParType.Enabled := False;
  end
  else
    MessageDlg('No BCMA Manager Access', mtError, [mbok], 0);
end;

procedure TfrmBCMAParameters.FormCloseQuery(Sender: TObject; var CanClose:
  Boolean);
begin
  //perform page check before closing
  if LeaveTsAnswerList then
  begin
    LeaveTsDefaultList_Warning := false;
    menuFileCloseClick(Sender);
  end
  else
    CanClose := false;
end;

procedure TfrmBCMAParameters.menuFileOpenClick(Sender: TObject);
var
  //  SaveMode: boolean;
  DefBCFormat: Integer;
  tmpVar: Integer;
begin
  if LeaveTsAnswerList then
  begin
    LeaveTsDefaultList_Warning := false;
    menuFileCloseClick(Sender);
    CurrentListName := '';
    //    Division := '';
    Division := BCMA_User.DivisionIEN; // rpk 6/24/2010
    if InputQuery('Division Selection', 'Enter Facility Division Number:',
      Division) then
      with BCMA_Broker do
      begin
        //SaveMode := DebugMode;
        //DebugMode := False;

        CallServer('PSB PARAMETER', ['GETDIV', Division], nil);
        if Results.Count < 7 then
        begin
          //          ShowMessage('Get Division returned less than 7 results = ' +
          //            IntToStr(Results.Count));
          MessageDlg('Internal error. Get Division should return 7 result lines; returned only '
            +
            IntToStr(Results.Count) + ' results.', mtError, [mbOK], 0);
        end
        else if piece(Results[0], '^', 1) <> '-1' then
        begin
          Division := piece(Results[0], '^', 2);
          edtFacName.Text := Results[1];
          edtAddress1.Text := Results[2];
          edtAddress2.Text := Results[3];
          edtAddressCity.Text := Results[4];
          edtAddressState.Text := Results[5];
          edtAddressZip.Text := Results[6];

          //System On-Line
          if GetParameter('PSB ONLINE', 1) <> '1' then
            cbxOnLine.State := cbUnChecked
          else
            cbxOnLine.State := cbChecked;

          //Maximum Server Clock Variance
          edtMaximumServerClockVariance.Text :=
            GetParameter('PSB Server Clock Variance', 2);

          //Require E-Sig to pass meds
          if GetParameter('PSB ADMIN ESIG', 1) <> '1' then
            cbxESig.State := cbUnChecked
          else
            cbxESig.State := cbChecked;

          // Include Continuous
          if GetParameter('PSB VDL INCL CONT', 1) <> '1' then
            cbxCont.State := cbUnChecked
          else
            cbxCont.State := cbChecked;

          // Include PRN
          if GetParameter('PSB VDL INCL PRN', 1) <> '1' then
            cbxPRN.State := cbUnChecked
          else
            cbxPRN.State := cbChecked;

          // Include One-Time
          if GetParameter('PSB VDL INCL ONE-TIME', 1) <> '1' then
            cbxOneTime.State := cbUnChecked
          else
            cbxOneTime.State := cbChecked;

          // Include On-Call
          if GetParameter('PSB VDL INCL ON-CALL', 1) <> '1' then
            cbxOnCall.State := cbUnChecked
          else
            cbxOnCall.State := cbChecked;

          //Using RobotRX
          if GetParameter('PSB ROBOT RX', 1) <> '1' then
            chkRobotRX.State := cbUnChecked
          else
            chkRobotRX.State := cbChecked;

          //Five Rights Unit Dose
          if GetParameter('PSB 5 RIGHTS UNITDOSE', 1) <> '1' then
            chk5UnitDose.State := cbUnChecked
          else
            chk5UnitDose.State := cbChecked;

          //Five Rights IV
          if GetParameter('PSB 5 RIGHTS IV', 1) <> '1' then
            chk5IV.State := cbUnChecked
          else
            chk5IV.State := cbChecked;

          //Rpt Max Range  {JK 5/9/2008}
          edtMaxDateRange.Text := GetParameter('PSB RPT MAX RANGE', 2);

          //Allow multiple Admins for On-Call
          if GetParameter('PSB ADMIN MULTIPLE ONCALL', 1) <> '1' then
            chkMultiAdmin.State := cbUnChecked
          else
            chkMultiAdmin.State := cbChecked;

          if GetParameter('PSB HKEY', 1) <> '1' then
            chkCPRSMedOrder.State := cbUnChecked
          else
            chkCPRSMedOrder.State := cbChecked;

          // Minutes Before
          cmbxMinBefore.ItemIndex :=
            StrToIntDef(GetParameter('PSB ADMIN BEFORE', 1), 0) div 10;

          // Minutes After
          cmbxMinAfter.ItemIndex := StrToIntDef(GetParameter('PSB ADMIN AFTER',
            1), 0) div 10;

          // Minutes PRN Effect
          cmbxPRNEffect.ItemIndex :=
            StrToIntDef(GetParameter('PSB ADMIN PRN EFFECT', 1), 0) div 10;

          // VDL Start Time
          cmbxStartTime.ItemIndex :=
            StrToIntDef(GetParameter('PSB VDL START TIME', 1), 0);

          // VDL Stop Time
          cmbxStopTime.ItemIndex :=
            StrToIntDef(GetParameter('PSB VDL STOP TIME', 1), 0);

          // Default Bar Code Format
          DefBCFormat := StrToIntDef(GetParameter('PSB DEFAULT BARCODE FORMAT',
            1), -1);
          if DefBCFormat <> -1 then
            cbxBCFormat.ItemIndex := DefBCFormat - 1
          else
            cbxBCFormat.ItemIndex := DefBCFormat;

          tmpVar := StrToIntDef(GetParameter('PSB VDL PATCH DAYS', 1), 0);
          if tmpVar > 0 then
            tmpVar := tmpVar - 6
          else
            tmpVar := 0;

          cbxPatchDuration.ItemIndex := tmpVar;

          // Scratch HFS Directory
          //edtHFSScratch.Text := GetParameter('PSB HFS SCRATCH', 1);  bjr 5/12/10 for BCMA00000425

          // Backup HFS Directory
          edtHFSBackup.Text := GetParameter('PSB PRINTER MISSING DOSE', 2);

          // General Error MG
          //edtMGSysError.Text := GetParameter('PSB MG SYSTEM ERROR', 2);

          // Due List Error MG
          edtMGDLError.Text := GetParameter('PSB MG DUE LIST ERROR', 2);

          // Missing Dose MG
          edtMGMissingDose.Text := GetParameter('PSB MG MISSING DOSE', 2);

          edtMGUnknown.Text := GetParameter('PSB MG ADMIN ERROR', 2);

          edtMGMSF.Text := GetParameter('PSB MG SCANNING FAILURES', 2);
          // Auto Update Mail Group
//            edtMGAutoUpdate.Text := GetParameter('PSB MG AUTOUPDATE', 2);

          //  Default Bar Code Prefix
          edtBCPrefix.Text := GetParameter('PSB DEFAULT BARCODE PREFIX', 2);

          edtPatientTransfer.Text := GetParameter('PSB PATIENT TRANSFER', 2);

          // PRN Documentation
          edtPRNDoc.Text := GetParameter('PSB PRN DOCUMENTATION', 2);

          edtTimeOut.Text := GetParameter('PSB IDLE TIMEOUT', 2);

          // Medication History Days Back
          edtMedHistDaysBack.Text := GetParameter('PSB MED HIST DAYS BACK', 2);

          // Reports include comments checkbox
          if GetParameter('PSB RPT INCL COMMENTS', 1) <> '1' then
            cbxRptInclComm.State := cbUnChecked
          else
            cbxRptInclComm.State := cbChecked;

          // Get The Lists
          cbxListName.Items.Clear;
          cbxListName.Items.AddObject('Reason Medication Given PRN',
            TObject(lnPRN));
          cbxListName.Items.AddObject('Reason Medication Held',
            TObject(lnHeld));
          cbxListName.Items.AddObject('Reason Medication Refused',
            TObject(lnRefused));
          cbxListName.Items.AddObject('Injection Sites', TObject(lnInjection));

          // empty the listview of any existing items
          lvwDefAnswer.Clear;

          // IHS tab should show only when running in IHS environment where agency
          // code is equal to I
          tbshtIHS.TabVisible := BCMA_User.AgencyCode = 'I';

          UpdateMode := True;
          PageControl1.Visible := True;
          PageControl1.ActivePage := tsFacility;
          cbxOnLine.SetFocus;
        end; // else Results[0] not -1
        //DebugMode := SaveMode;
      end; // with BCMA_Broker
  end; // if LeaveTsAnswerList
end;

function TfrmBCMAParameters.GetParameter(Parameter: string; UpArrowPiece:
  Integer): string;
begin
  Result := '';
  BCMA_Broker.CallServer('PSB PARAMETER', ['GETPAR', Division,
    uppercase(Parameter)], nil);
  Result := piece(BCMA_Broker.Results[0], '^', UpArrowPiece);
end;

function TfrmBCMAParameters.GetParameterLevel(Parameter: string; Level: string;
  UpArrowPiece: Integer): string;
begin
  Result := '';
  BCMA_Broker.CallServer('PSB PARAMETER', ['GETPAR', Level,
    uppercase(Parameter)], nil);
  Result := piece(BCMA_Broker.Results[0], '^', UpArrowPiece);
end;

function TfrmBCMAParameters.SetParameter(Parameter: string; newValue: string):
  Boolean;
begin
  Result := False;
  if UpdateMode then
  begin
    //messagedlg('Update Parameter ' + Parameter + ' to ' + newValue,mtInformation,[mbyes,mbno],0);
    BCMA_Broker.CallServer('PSB PARAMETER', ['SETPAR', Division, Parameter, '1',
      newValue], nil);
    if piece(BCMA_Broker.Results[0], '^', 1) = '-1' then
      messagedlg('Invalid Parameter Value', mtError, [mbok], 0)
    else
      Result := True;
  end;
end;

procedure TfrmBCMAParameters.WhatsThis1Popup(Sender, HelpItem: TObject;
  HContext: THelpContext; X, Y: Integer; var DoPopup: Boolean);
begin
  //since the control the user clicked on isn't easily available,
  //we'll use the HContext to determine if this is a control where we want
  //to disable the right click popup 'what's this?'
//  case HContext of
//    30, // the vdl, already has right click options
//    300, //Edit Med Log, grdMedications
//    902, //coversheet, already has right click options.
//    150: //Multiple Drugs CheckListBox
//      DoPopup := false;
//  end;

end;

procedure TfrmBCMAParameters.menuFileCloseClick(Sender: TObject);
begin
  //perform page check before closing file
  if LeaveTsAnswerList then
  begin
    PageControl1.Visible := False;
    UpdateMode := False;
  end;
end;

procedure TfrmBCMAParameters.menuFileExitClick(Sender: TObject);
begin
  if LeaveTsAnswerList then
  begin
    LeaveTsDefaultList_Warning := false;
    menuFileCloseClick(Sender);
    LeaveTsDefaultList_Warning := false;
    //  Application.Terminate;
    Close;
  end;
end;

procedure TfrmBCMAParameters.mnListerPopup(Sender: TObject);
begin

  // build popup menu
  mnLister.Items[0].Caption := '&Add New ...';
  mnLister.Items[1].Caption := '&Edit ...';
  mnLister.Items[2].Caption := '&Delete';

  //disable all options if there's no list selected
  if cbxListName.ItemIndex = -1 then
  begin
    mnLister.Items[0].enabled := False;
    mnLister.Items[1].enabled := False;
    mnLister.Items[2].enabled := False;
  end

  else // turn on options

  begin
    //enable Add New
    mnLister.Items[0].enabled := True;

    // enable/disable Edit and Delete if and item is selected
    if cbxListName.Items.Count > 0 then
    begin
      mnLister.Items[1].enabled := (lvwDefAnswer.ItemIndex > -1);
      mnLister.Items[2].enabled := (lvwDefAnswer.ItemIndex > -1);
    end;
  end;
end;

procedure TfrmBCMAParameters.cbxOnLineClick(Sender: TObject);
begin
  if cbxOnLine.State = cbChecked then
    SetParameter('PSB ONLINE', 'Y')
  else if
    messageDlg('You are about to disable BCMA for ALL users in this division!' +
    #13#13 +
    'Click OK to continue.',
    mtWarning, [mbOK, mbCancel], 0) = mrOK then
    SetParameter('PSB ONLINE', 'N')
  else
    cbxOnLine.State := cbChecked;
end;

procedure TfrmBCMAParameters.cbxESigClick(Sender: TObject);
begin
  if cbxESig.State = cbChecked then
    SetParameter('PSB ADMIN ESIG', 'Y')
  else
    SetParameter('PSB ADMIN ESIG', 'N');
end;

procedure TfrmBCMAParameters.cbxContClick(Sender: TObject);
begin
  if cbxCont.State = cbChecked then
    SetParameter('PSB VDL INCL CONT', 'Y')
  else
    SetParameter('PSB VDL INCL CONT', 'N');
end;

procedure TfrmBCMAParameters.cbxPRNClick(Sender: TObject);
begin
  if cbxPRN.State = cbChecked then
    SetParameter('PSB VDL INCL PRN', 'Y')
  else
    SetParameter('PSB VDL INCL PRN', 'N');
end;

procedure TfrmBCMAParameters.cbxOneTimeClick(Sender: TObject);
begin
  if cbxOneTime.State = cbChecked then
    SetParameter('PSB VDL INCL ONE-TIME', 'Y')
  else
    SetParameter('PSB VDL INCL ONE-TIME', 'N');
end;

procedure TfrmBCMAParameters.cbxOnCallClick(Sender: TObject);
begin
  if cbxOnCall.State = cbChecked then
    SetParameter('PSB VDL INCL ON-CALL', 'Y')
  else
    SetParameter('PSB VDL INCL ON-CALL', 'N');
end;

procedure TfrmBCMAParameters.cmbxStartTimeClick(Sender: TObject);
begin
  SetParameter('PSB VDL START TIME', IntToStr(cmbxStartTime.ItemIndex));
end;

procedure TfrmBCMAParameters.cmbxStopTimeClick(Sender: TObject);
begin
  SetParameter('PSB VDL STOP TIME', IntToStr(cmbxStopTime.ItemIndex));
end;

procedure TfrmBCMAParameters.cmbxMinBeforeClick(Sender: TObject);
begin
  SetParameter('PSB ADMIN BEFORE', IntToStr(cmbxMinBefore.ItemIndex * 10));
end;

procedure TfrmBCMAParameters.cmbxMinAfterClick(Sender: TObject);
begin
  SetParameter('PSB ADMIN AFTER', IntToStr(cmbxMinAfter.ItemIndex * 10));
end;

procedure TfrmBCMAParameters.cmbxPRNEffectClick(Sender: TObject);
begin
  SetParameter('PSB ADMIN PRN EFFECT', IntToStr(cmbxPRNEffect.ItemIndex * 10));
end;

procedure TfrmBCMAParameters.edtEnter(Sender: TObject);
begin
  TEdit(Sender).Tag := 0;
end;

procedure TfrmBCMAParameters.edtChange(Sender: TObject);
begin
  TEdit(Sender).Tag := 1;
end;

{procedure TfrmBCMAParameters.edtHFSScratchExit(Sender: TObject);
begin
  if edtHFSScratch.Tag <> 0 then
    if not SetParameter('PSB HFS SCRATCH', edtHFSScratch.Text) then
      edtHFSScratch.Text := GetParameter('PSB HFS SCRATCH', 1);
  edtHFSScratch.Tag := 0;
end;  bjr 5/12/10 for BCMA00000425}

procedure TfrmBCMAParameters.edtHFSBackupExit(Sender: TObject);
begin
  if edtHFSBackup.Tag <> 0 then
    if not SetParameter('PSB PRINTER MISSING DOSE', edtHFSBackup.Text) then
      edtHFSBackup.Text := GetParameter('PSB PRINTER MISSING DOSE', 2);
  edtHFSBackup.Tag := 0;
end;

procedure TfrmBCMAParameters.edtMGSysErrorExit(Sender: TObject);
begin
  //  if edtMGSysError.Tag <> 0 then
  //    if not SetParameter('PSB MG SYSTEM ERROR', edtMGSysError.Text) then
  //      edtMGSysError.Text := GetParameter('PSB MG SYSTEM ERROR', 2);
  //  edtMGSysError.Tag := 0;
end;

procedure TfrmBCMAParameters.edtMGDLErrorExit(Sender: TObject);
begin
  if edtMGDLError.Tag <> 0 then
    if not SetParameter('PSB MG DUE LIST ERROR', edtMGDLError.Text) then
      edtMGDLError.Text := GetParameter('PSB MG DUE LIST ERROR', 2);
  edtMGDLError.Tag := 0;
end;

procedure TfrmBCMAParameters.edtMGMissingDoseExit(Sender: TObject);
begin
  if edtMGMissingDose.Tag <> 0 then
    if not SetParameter('PSB MG MISSING DOSE', edtMGMissingDose.Text) then
      edtMGMissingDose.Text := GetParameter('PSB MG MISSING DOSE', 2);
  edtMGMissingDose.Tag := 0;
end;

procedure TfrmBCMAParameters.mnListAddClick(Sender: TObject);
var
  newVal: string; // holds the value of the item name
  ListItem: TListItem; // reference to the current ListVeiw Row
  CheckState: Boolean; // holds the state of the inputPromp() checkbox
  Attribute: string; // holds the value of the items attribute (req pain)

begin
  // set defaults
  CheckState := false;
  newVal := '';
  Attribute := '';

  // don't allow the user to enter more than 100 items in a list
  if lvwDefAnswer.Items.Count >= 100 then
  begin
    MessageDlg('A maximum of 100 entries have already been entered!',
      mtWarning, [mbOK], 0);
    exit;
  end;

  //prompt user for the new item
  if TListNames(cbxListName.Items.Objects[cbxListName.ItemIndex]) = lnPRN then
  begin // and include pain score checkbox for PRN list
    newVal := inputPrompt('Add New Item', 'Item:', '', 30, false, false,
      CheckState, 'Requires Pain Score');
  end
  else
  begin // don't include any check box
    newVal := inputPrompt('Add New Item', 'Item:', '', 30, false, false,
      CheckState, '');
  end;

  //remove leading and trailing spaces before we check for null
  newVal := StripString(newVal, True);
  if newVal <> '' then
  begin
    // add the item to the List view (column 1)
    ListItem := lvwDefAnswer.Items.Add;
    ListItem.Caption := newVal;

    // Covert Attribute to text
    if CheckState = true then
      Attribute := 'Requires Pain Score';

    // add the attribute to the ListView (column 2)
    ListItem.SubItems.Add(Attribute);

    btnSaveList.Enabled := True;
  end;
end;

procedure TfrmBCMAParameters.mnDeleteItemClick(Sender: TObject);
begin
  with lvwDefAnswer do
    if ItemIndex > -1 then
    begin
      Items.Delete(ItemIndex);
      btnSaveList.Enabled := True;
    end;
end;

procedure TfrmBCMAParameters.mnListEditClick(Sender: TObject);
var
  newVal: string; // the value of the item name
  curVal: string; // the existing value of the item
  listItem: TListItem; // reference to the current ListVeiw Row
  CheckState: boolean; // the state of the inputPromp() checkbox
  curCheckState: boolean; // the existing state of cbx
  Attribute: string; // the value of the items attribute (req pain)

begin
  with lvwDefAnswer do
    if ItemIndex > -1 then
    begin

      //preset existing values
      Attribute := '';
      newVal := Items[ItemIndex].Caption;
      curVal := newVal;
      CheckState := false;
      curCheckState := false;
      if TListNames(cbxListName.Items.Objects[cbxListName.ItemIndex]) = lnPRN
        then
      begin;
        if Items[ItemIndex].subitems[0] = 'Requires Pain Score' then
        begin;
          CheckState := true;
          curCheckState := true;
        end;
      end;

      //prompt user for the new item and only add checkbox for PRN's
      if TListNames(cbxListName.Items.Objects[cbxListName.ItemIndex]) = lnPRN
        then
        // and include pain score checkbox
      begin
        newVal := inputPrompt('Edit Item', 'Item:', newVal, 30, false, false,
          CheckState, 'Requires Pain Score');
      end
      else
        // don't include any check box
      begin
        newVal := inputPrompt('Edit Item', 'Item:', newVal, 30, false, false,
          CheckState, '');
      end;

      //strip invalid chars and trailing sp... warn user...
      newVal := StripString(newVal, True);
      // don't add if there's no item name or if nothing changed
      if newVal <> '' then
        if ((newVal <> curVal) or (checkState <> curCheckState)) then
        begin
          Items.Delete(ItemIndex);
          listItem := Items.Add;
          listItem.Caption := newVal;

          // set if checkbox was checked
          if CheckState = true then
            Attribute := 'Requires Pain Score';

          ListItem.SubItems.Add(Attribute);
          btnSaveList.Enabled := True;
        end;
    end;
end;

procedure TfrmBCMAParameters.btnSaveListClick(Sender: TObject);
var
  i: integer; // counter for item loop
  Parameter: string; // site parameter being saved
  ItemAttrib: string; // flag for "requries pain score" in prn list

begin
  // default Attribute to nothing
  ItemAttrib := '';

  if TListNames(cbxListName.Items.Objects[cbxListName.ItemIndex]) = lnPRN then
    Parameter := 'PSB LIST REASONS GIVEN PRN';
  if TListNames(cbxListName.Items.Objects[cbxListName.ItemIndex]) = lnHeld then
    Parameter := 'PSB LIST REASONS HELD';
  if TListNames(cbxListName.Items.Objects[cbxListName.ItemIndex]) = lnRefused
    then
    Parameter := 'PSB LIST REASONS REFUSED';
  if TListNames(cbxListName.Items.Objects[cbxListName.ItemIndex]) = lnInjection
    then
    Parameter := 'PSB LIST INJECTION SITES';

  //delete the entire list before we save the new list
  BCMA_Broker.CallServer('PSB PARAMETER', ['DELLST', Division, Parameter], nil);

  //save each item in the current listveiw
  for i := 0 to lvwDefAnswer.Items.Count - 1 do
  begin

    // add the pain score flage to PRN Reasons
    if TListNames(cbxListName.Items.Objects[cbxListName.ItemIndex]) = lnPRN then
    begin
      if lvwDefAnswer.Items[i].SubItems[0] = 'Requires Pain Score' then
        ItemAttrib := '|1'
      else
        ItemAttrib := '|0';
    end;

    // save the parameter
    BCMA_Broker.CallServer('PSB PARAMETER',
      ['SETPAR', Division, Parameter, IntToStr(i + 1),
      lvwDefAnswer.Items[i].Caption + ItemAttrib],
        nil);
    // warn the user if an Item is not saved.
    if piece(BCMA_Broker.Results[0], '^', 1) = '-1' then
      messagedlg('Invalid Parameter Value [' + lvwDefAnswer.Items[i].Caption +
        '] was not saved.',
        mtError, [mbok], 0)

  end;
  //disable the save button and refresh the
  btnSaveList.Enabled := False;
  cbxListName.OnChange(btnSaveList);
end;

procedure TfrmBCMAParameters.menuHelpAboutClick(Sender: TObject);
begin
  //  messagedlg('BCMA Parameters Setup - Version 1.0',mtinformation,[mbok],0);
  AboutDlg.Execute;
end;

procedure TfrmBCMAParameters.edtMaxDateRangeExit(Sender: TObject);
begin
  if edtMaxDateRange.Tag <> 0 then
    if not SetParameter('PSB RPT MAX RANGE', edtMaxDateRange.Text) then
    begin
      edtMaxDateRange.Text := GetParameter('PSB RPT MAX RANGE', 2);
      if PageControl1.Visible then
        edtMaxDateRange.SetFocus;
    end;
  edtMaxDateRange.Tag := 0;
end;

procedure TfrmBCMAParameters.edtMaximumServerClockVarianceExit(Sender: TObject);
begin
  if edtMaximumServerClockVariance.Tag <> 0 then
    if not SetParameter('PSB SERVER CLOCK VARIANCE',
      edtMaximumServerClockVariance.Text) then
      edtMaximumServerClockVariance.Text :=
        GetParameter('PSB SERVER CLOCK VARIANCE', 2);
  edtMaximumServerClockVariance.Tag := 0;
end;

procedure TfrmBCMAParameters.menuHelpContentsClick(Sender: TObject);
begin
  with Application do
    //	if not HelpCommand(HELP_CONTENTS, 0) then
    if not HelpCommand(HELP_FINDER, 0) then
      messageDlg('Error accessing ' + application.helpfile, mtError, [mbOK], 0);
end;

procedure TfrmBCMAParameters.menuHelpIndexClick(Sender: TObject);
begin
  with Application do
    if not HelpCommand(HELP_INDEX, 0) then
      DefMessageDlg('Error accessing ' + application.helpfile, mtError, [mbOK],
        0);
end;

procedure TfrmBCMAParameters.PageControl1Change(Sender: TObject);
//var
//  i: integer;
begin
  with PageControl1 do
    if ActivePage = tsFacility then
      cbxOnLine.SetFocus
        {else if ActivePage = tsParameters then
edtHFSScratch.setFocus  bjr 5/12/10 for BCMA00000425}
    else if ActivePage = tsAnswerList then
    begin
      cbxListName.setFocus;
      cbxListName.ItemIndex := 0;
      cbxListName.OnChange(self);
    end
    else if ActivePage = tbshtIVParameters then
    begin
      getwardlist;
      cbxIVParWard.ItemIndex := 0;
      cbxIVParWardChange(cbxIVParWard);
    end
    else if ActivePage = tbshtIHS then
    begin
      LoadIHS;
    end;

end;

procedure TfrmBCMAParameters.cbxListNameChange(Sender: TObject);
var
  i: integer; //counter to walk thru the broker results
  Parameter: string; //parameter list being retrieved by broker
  ListItem: TListItem; //item being added to the listview

begin

  // only perform the chagne if a new list is selected.
  // or as a refresh after the save button is clicked.
  if (currentListName <> cbxListName.text) or (Sender = btnSaveList) then
  begin
    lvwDefAnswer.Items.Clear; // remove entries from the ListView
    currentListName := cbxListName.text;
    currentListIndex := cbxListName.ItemIndex;
    Parameter := '';

    // adjust the 2nd column based on the list selected
    if TListNames(cbxListName.Items.Objects[cbxListName.ItemIndex]) <> lnPRN
      then
    begin
      //hide the 2nd column and delete the header caption
      lvwDefAnswer.Columns[1].Caption := '';
      lvwDefAnswer.Columns[1].Width := 0;
      lvwDefAnswer.Columns[0].Width := lvwDefAnswer.Width - 4;
    end
    else
    begin
      //show the 2nd column and set the header caption
      lvwDefAnswer.Columns[1].Caption := 'Attribute';
      lvwDefAnswer.Columns[1].Width := (lvwDefAnswer.Width div 2) - 2;
      lvwDefAnswer.Columns[0].Width := (lvwDefAnswer.Width div 2) - 2;
    end;

    // prep parameter for the broker call
    if cbxListName.Text <> '' then
      case TListNames(cbxListName.Items.Objects[cbxListName.ItemIndex]) of
        lnPRN: Parameter := 'PSB LIST REASONS GIVEN PRN';
        lnHeld: Parameter := 'PSB LIST REASONS HELD';
        lnRefused: Parameter := 'PSB LIST REASONS REFUSED';
        lnInjection: Parameter := 'PSB LIST INJECTION SITES';
      else
        exit;
      end;

    // retrieve list values
    if Parameter <> '' then
      with BCMA_Broker do
      begin
        if CallServer('PSB PARAMETER', ['GETLST', Division, Parameter], nil)
          then
          for i := 1 to BCMA_Broker.Results.Count - 1 do
          begin
            // at item name to column 1 of the list view
            // always use piece to allow additional future to be added w/o impact
            ListItem := lvwDefAnswer.Items.Add;
            ListItem.Caption := piece(BCMA_Broker.Results[i], '|', 1);

            //add attribute to column 2 for PRNs
            if TListNames(cbxListName.Items.Objects[cbxListName.ItemIndex]) =
              lnPRN then
            begin
              // attribute as 2nd piece
              if piece(BCMA_Broker.Results[i], '|', 2) = '1' then
                ListItem.SubItems.Add('Requires Pain Score')
              else
                ListItem.SubItems.Add('');
            end
            else
              // add empty subItem to all other lists
              ListItem.SubItems.Add('');
          end;

        // disable the SAVE LIST button if we've changed lists.
        btnSaveList.Enabled := false;
      end;
  end;
end;

procedure TfrmBCMAParameters.getwardlist();
var
  i: Integer;
begin
  with BCMA_WardList do
  begin
    LoadWardData;
    cbxIVParWard.Items.Clear;
    for i := 0 to Wards.Count - 1 do
      cbxIVParWard.Items.Add(TBCMA_WardList(Wards[i]).WardName);
  end;
end;

procedure TfrmBCMAParameters.lbledtPatIdLabelExit(Sender: TObject);
begin
  lbledtPatIdLabel.Text := AnsiUpperCase(lbledtPatIdLabel.Text);
  SaveIHS;
end;

procedure TfrmBCMAParameters.cbxIVParWardDrawItem(Control: TWinControl;
  Index: Integer; Rect: TRect; State: TOwnerDrawState);
var
  ii: Integer;
begin
  with BCMA_WardList do
  begin
    for ii := 0 to Wards.count - 1 do
      if TBCMA_WardList(Wards[ii]).WardName = cbxIVParWard.items[index] then
        if TBCMA_WardList(Wards[ii]).BCMAWard = 1 then
        begin
          cbxIVParWard.canvas.Font.Style := [fsbold, fsunderline];
          //cbxIVParWard.Canvas.Font.Color := clHighlightText;
          Break;
        end;
  end;
  with cbxIVParWard do
  begin
    canvas.fillrect(rect);
    canvas.textout(rect.left, rect.top, items[index]);
  end;
end;

procedure TfrmBCMAParameters.cbxIVParWardChange(Sender: TObject);
var
  ii: Integer;
begin

  cbxIVParWard.hint := cbxIVParWard.text;
  with cbxIVParType do
  begin
    Items.Clear;
    Items.Add('Admixture');
    Items.Add('Chemotherapy');
    Items.Add('Hyperal');
    Items.Add('Piggyback');
    Items.Add('Syringe');
  end;
  cbxIVParType.ItemIndex := 0;
  SelectedWardIEN := '';

  with BCMA_WardList do
  begin
    for ii := 0 to Wards.count - 1 do
      if TBCMA_WardList(Wards[ii]).WardName =
        cbxIVParWard.Items[cbxIVParWard.ItemIndex] then
      begin
        ClearAll;
        SelectedWardIEN := TBCMA_WardList(Wards[ii]).IEN;
        if TBCMA_WardList(Wards[ii]).BCMAWard = 1 then
        begin
          GetIVPar('A');
          btnReset.Enabled := true
        end
        else
          btnReset.Enabled := false;

        Break
      end;
  end;
  cbxIVParType.Enabled := True;
  grpIVPrompts.Enabled := True;
  if cbxIVParWard.ItemIndex = 0 then
    btnReset.Enabled := false
      //  else
//    btnReset.Enabled := True;

end;

procedure TfrmBCMAParameters.cbxIVParTypeDrawItem(Control: TWinControl;
  Index: Integer; Rect: TRect; State: TOwnerDrawState);
var
  zbold: Boolean;
  ii: integer;
begin
  zbold := False;
  with BCMA_WardList do
  begin
    for ii := 0 to Wards.count - 1 do
      if TBCMA_WardList(Wards[ii]).WardName =
        cbxIVParWard.Items[cbxIVParWard.ItemIndex] then
      begin
        case Index of
          0:
            if TBCMA_WardList(Wards[ii]).Admixture = 1 then
              zbold := True;
          1:
            if TBCMA_WardList(Wards[ii]).Chemo = 1 then
              zbold := True;
          2:
            if TBCMA_WardList(Wards[ii]).Hyperal = 1 then
              zbold := True;
          3:
            if TBCMA_WardList(Wards[ii]).PiggyBack = 1 then
              zbold := True;
          4:
            if TBCMA_WardList(Wards[ii]).Strings = 1 then
              zbold := True;
        end;
        break;
      end
  end;
  if zbold = True then
  begin
    cbxIVParType.canvas.Font.Style := [fsbold, fsunderline];
    //cbxIVParType.Canvas.Font.Color := clNavy;
  end;
  with cbxIVParType do
  begin
    canvas.fillrect(rect);
    canvas.textout(rect.left, rect.top, items[index]);
  end;

end;

procedure TfrmBCMAParameters.GetIVPar(Value: string);
var
  i: integer;
  zControl: TControl;
begin
  with BCMA_Broker do
    if CallServer('PSB GETIVPAR', [SelectedWardIEN, Value, piece(Division, ';',
        1)], nil) then
      if piece(Results[0], '^', 1) = '-1' then
      begin
        ClearAll;
        btnReset.enabled := False;
        MessageDlg(piece(Results[0], '^', 2), mtWarning, [mbOK], 0)
      end
      else
      begin
        btnReset.enabled := True;
        for i := 0 to grpIVPrompts.ControlCount - 1 do
        begin
          zControl := grpIVPrompts.Controls[i];
          if zControl is TComboBox then
          begin
            TComboBox(zControl).ItemIndex := StrToInt(piece(Results[0], '^',
              grpIVPrompts.Controls[i].Tag)) - 1;
          end;
        end;
      end;

end;

procedure TfrmBCMAParameters.cbxIVParTypeChange(Sender: TObject);
//var
//  ii: integer;
begin
  if SelectedWardIEN <> '' then
  begin
    GetIVPar(Copy(cbxIVParType.Text, 1, 1));
    //btnReset.enabled := False;
  end
  else
    btnReset.enabled := False;
end;

procedure TfrmBCMAParameters.ClearAll();
var
  i: Integer;
begin
  for i := 0 to grpIVPrompts.ControlCount - 1 do
    if grpIVPrompts.Controls[i] is TComboBox then
      TComboBox(grpIVPrompts.Controls[i]).ItemIndex := -1
end;

procedure TfrmBCMAParameters.cbxBCFormatClick(Sender: TObject);
begin
  SetParameter('PSB DEFAULT BARCODE FORMAT', cbxBCFormat.text);
end;

procedure TfrmBCMAParameters.edtBCPrefixExit(Sender: TObject);
begin
  if edtBCPrefix.Tag <> 0 then
    if not SetParameter('PSB DEFAULT BARCODE PREFIX', edtBCPrefix.Text) then
      edtBCPrefix.Text := GetParameter('PSB DEFAULT BARCODE PREFIX', 2);
  edtBCPrefix.Tag := 0;

end;

procedure TfrmBCMAParameters.chkRobotRXClick(Sender: TObject);
begin
  if chkRobotRX.State = cbChecked then
    SetParameter('PSB ROBOT RX', 'Y')
  else
    SetParameter('PSB ROBOT RX', 'N');
end;

procedure TfrmBCMAParameters.chkMultiAdminClick(Sender: TObject);
begin
  if chkMultiAdmin.State = cbChecked then
    SetParameter('PSB ADMIN MULTIPLE ONCALL', 'Y')
  else
    SetParameter('PSB ADMIN MULTIPLE ONCALL', 'N');

end;

procedure TfrmBCMAParameters.edtPatientTransferExit(Sender: TObject);
begin
  if edtPatientTransfer.Tag <> 0 then
    if not SetParameter('PSB PATIENT TRANSFER', edtPatientTransfer.Text) then
    begin
      edtPatientTransfer.Text := GetParameter('PSB PATIENT TRANSFER', 2);
      if PageControl1.Visible then
        edtPatientTransfer.SetFocus;
    end;
  edtPatientTransfer.Tag := 0;
end;

procedure TfrmBCMAParameters.edtPRNDocExit(Sender: Tobject);
begin
  if edtPRNDoc.Tag <> 0 then
    if not SetParameter('PSB PRN DOCUMENTATION', edtPRNDoc.Text) then
    begin
      edtPRNDoc.Text := GetParameter('PSB PRN DOCUMENTATION', 2);
      if PageControl1.Visible then
        edtPRNDoc.SetFocus;
    end;
  edtPRNDoc.Tag := 0;
end;

procedure TfrmBCMAParameters.PutIVPar();
var
  i: integer;
  Param1, Param2: string;
  zControl: TControl;

begin
  Param1 := '';
  Param2 := '';

  for i := 0 to grpIVPrompts.ControlCount - 1 do
  begin
    zControl := grpIVPrompts.Controls[i];
    if zControl is TComboBox then
    begin
      SetPiece(Param2, '^', grpIVPrompts.Controls[i].Tag - 1,
        IntToStr(TComboBox(zControl).ItemIndex + 1));
    end;
  end;

  Param1 := cbxIVParWard.Items[cbxIVParWard.ItemIndex] + '^' + SelectedWardIEN;

  Param2 := Copy(cbxIVParType.Text, 1, 1) + '^' + Param2;

  with BCMA_Broker do
    if CallServer('PSB PUTIVPAR', [Param1, Param2, piece(Division, ';', 1)], nil)
      then

end;

procedure TfrmBCMAParameters.btnIVParOKClick(Sender: TObject);
var
  i: integer;
  zControl: TControl;
begin

  for i := 0 to grpIVPrompts.ControlCount - 1 do
  begin
    zControl := grpIVPrompts.Controls[i];
    if zControl is TComboBox then
    begin
      if TComboBox(grpIVPrompts.Controls[i]).ItemIndex = -1 then
      begin
        messageDlg('All IV Prompts must be defined!',
          mtError, [mbOK], 0);
        exit;
      end;
    end;
  end;

  PutIVPar;
  getwardlist;
  cbxIVParWard.ItemIndex := 0;
  cbxIVParWardChange(cbxIVParWard);

end;

procedure TfrmBCMAParameters.btnResetClick(Sender: TObject);
var
  Param1,
    Param2: string;
begin
  if
    messageDlg('Ward settings will revert to the default Division (ALL) settings.'
    + #13#13,
    mtWarning, [mbOK, mbCancel], 0) = mrCancel then
    exit;

  Param1 := cbxIVParWard.Items[cbxIVParWard.ItemIndex] + '^' + SelectedWardIEN;

  Param2 := Copy(cbxIVParType.Text, 1, 1);

  with BCMA_Broker do
    if CallServer('PSB PUTIVPAR', [Param1, Param2, piece(Division, ';', 1)], nil)
      then

      getwardlist;
  cbxIVParWard.ItemIndex := 0;
  cbxIVParWardChange(cbxIVParWard);

end;

procedure TfrmBCMAParameters.ComboBox1Change(Sender: TObject);
begin
  if (TComboBox(Sender).Tag = 7) or (TComboBox(Sender).Tag = 12) then
  begin
    if TComboBox(Sender).ItemIndex <> 0 then
      messageDlg('The recommended selection for this parameter is "Warning."',
        mtInformation, [mbOK], 0);
  end
  else if TComboBox(Sender).ItemIndex <> 2 then
    messageDlg('The recommended selection for this parameter is "Invalid Bag."',
      mtInformation, [mbOK], 0);
end;

procedure TfrmBCMAParameters.edtTimeoutExit(Sender: TObject);
begin
  if edtTimeout.Tag <> 0 then
    if not SetParameter('PSB IDLE TIMEOUT', edtTimeOut.Text) then
    begin
      edtTimeOut.Text := GetParameter('PSB IDLE TIMEOUT', 2);
      if PageControl1.Visible then
        edtTimeout.SetFocus;
    end;
  edtTimeOut.Tag := 0;
end;

procedure TfrmBCMAParameters.chkCPRSMedOrderClick(Sender: TObject);
begin
  if chkCPRSMedOrder.State = cbChecked then
    SetParameter('PSB HKEY', 'Y')
  else
    SetParameter('PSB HKEY', 'N');

end;

procedure TfrmBCMAParameters.FormDestroy(Sender: TObject);
begin
  BCMA_Broker.Free;
end;

procedure TfrmBCMAParameters.cbxListNameSelect(Sender: TObject);
begin
  if not LeaveTsAnswerList then
    cbxListName.ItemIndex := currentListIndex;

  //the onSelect event seems to short curciut the onChange event
  //so we have to continue the process ourselves.
  cbxListName.OnChange(self);
end;

function TfrmBCMAParameters.LeaveTsAnswerList: Boolean;
(*  determine if the current list has been saved. Warn user and return users
    response.

    Returns   TRUE  - if ok to leave page
                    - or if tsAnswerList is not active

              FALSE - if user chooses not to leave.

    Set LeaveTsDefaultList_Warning to False to disable the warning "once"
*)
begin
  Result := True;
  with PageControl1 do
    if (LeaveTsDefaultList_Warning) and (ActivePage = tsAnswerList) then
    begin
      // warn the user if changes have not been saved
      if btnSaveList.Enabled = true then
        if messageDlg('Changes to the "' + currentListName +
          '" list have not been saved!' + #13#13 +
          'Click OK to continue without saving your changes.',
          mtWarning, [mbOK, mbCancel], 0) = mrCancel then
          //stop the change
        begin
          Result := False;
        end
        else
          // turn off the save button to prevent repeat warnings
          btnSaveList.Enabled := False;

    end;
  //reset warning
  LeaveTsDefaultList_Warning := true;
end;

procedure TfrmBCMAParameters.PageControl1Changing(Sender: TObject;
  var AllowChange: Boolean);
begin
  // perform page checks before allowing the change
  with PageControl1 do
    if LeaveTsAnswerList then
      // allow the change
    begin
      // clear the currentListName so the list reloads if the user
      // comes back to this tab.
      currentListName := '';
    end
    else
      // stop page change
    begin
      AllowChange := False;
    end;
end;

procedure TfrmBCMAParameters.edtMedHistDaysBackChange(Sender: TObject);
begin
  TEdit(Sender).Tag := 1;
end;

procedure TfrmBCMAParameters.edtMedHistDaysBackEnter(Sender: TObject);
begin
  TEdit(Sender).Tag := 0;
end;

procedure TfrmBCMAParameters.edtMedHistDaysBackExit(Sender: TObject);
begin
  if edtMedHistDaysBack.Tag <> 0 then
    if not SetParameter('PSB MED HIST DAYS BACK', edtMedHistDaysBack.Text) then
    begin
      edtMedHistDaysBack.Text := GetParameter('PSB MED HIST DAYS BACK', 2);
      if PageControl1.Visible then
        edtMedHistDaysBack.SetFocus;
    end;
  edtMedHistDaysBack.Tag := 0;
end;

procedure TfrmBCMAParameters.cbxRptInclCommClick(Sender: TObject);
begin
  if cbxRptInclComm.State = cbChecked then
    SetParameter('PSB RPT INCL COMMENTS', 'Y')
  else
    SetParameter('PSB RPT INCL COMMENTS', 'N');
end;

procedure TfrmBCMAParameters.chk5UnitDoseClick(Sender: TObject);
begin
  if chk5UnitDose.State = cbChecked then
    SetParameter('PSB 5 RIGHTS UNITDOSE', '1')
  else
    SetParameter('PSB 5 RIGHTS UNITDOSE', '0');
end;

procedure TfrmBCMAParameters.chk5IVClick(Sender: TObject);
begin
  if chk5IV.State = cbChecked then
    SetParameter('PSB 5 RIGHTS IV', '1')
  else
    SetParameter('PSB 5 RIGHTS IV', '0');
end;

procedure TfrmBCMAParameters.cbxPatchDurationClick(Sender: TObject);
//var
//  DayToDisplay: integer;
begin
  if cbxPatchDuration.ItemIndex = 0 then
    SetParameter('PSB VDL PATCH DAYS', '')
  else
    SetParameter('PSB VDL PATCH DAYS', IntToStr(cbxPatchDuration.ItemIndex +
      6));
end;

procedure TfrmBCMAParameters.edtMgUnknownExit(Sender: TObject);
begin
  if edtMGUnknown.Tag <> 0 then
    if not SetParameter('PSB MG ADMIN ERROR', edtMGUnknown.Text) then
    begin
      edtMGUnknown.Text := GetParameter('PSB MG ADMIN ERROR', 2);
      if PageControl1.Visible then
        edtMgUnknown.SetFocus;
    end;
  edtMGUnknown.Tag := 0;

end;

procedure TfrmBCMAParameters.edtMGMSFExit(Sender: TObject);
begin
  if edtMGMSF.Tag <> 0 then
    if not SetParameter('PSB MG SCANNING FAILURES', edtMGMSF.Text) then
    begin
      edtMGMSF.Text := GetParameter('PSB MG SCANNING FAILURES', 2);
      if PageControl1.Visible then
        edtMgMSF.SetFocus;
    end;
  edtMGMSF.Tag := 0;

end;

procedure TfrmBCMAParameters.LoadIHS;
begin
  //  lbledtDivPatIdLabel.Text := GetParameterLevel('PSB PATIENT ID LABEL', 'DIV', 1);
  lbledtDivPatIdLabel.Text := GetParameter('PSB PATIENT ID LABEL', 1);
  lbledtSysPatIdLabel.Text := GetParameterLevel('PSB PATIENT ID LABEL', 'SYS',
    1);
  lbledtAllPatIdLabel.Text := GetParameterLevel('PSB PATIENT ID LABEL', 'ALL',
    1);

  if lbledtDivPatIdLabel.Text <> '' then
    lbledtPatIdLabel.Text := lbledtDivPatIdLabel.Text
  else
    lbledtPatIdLabel.Text := lbledtSysPatIdLabel.Text
end;

procedure TfrmBCMAParameters.SaveIHS;
var
  tpidlbl, updstr: string;
  bres: Boolean;
begin
  // if the user input is the same as the system-level value, we want to delete the
  // division-level value.  Then, the GETPAR ALL in BCMA will fall through and retrieve
  // the system-level value.
  if lbledtPatIdLabel.Text = lbledtSysPatIdLabel.Text then
    tpidlbl := ''
  else
    tpidlbl := lbledtPatIdLabel.Text;

  // if the new desired value is different from the current division-level value,
  // call SETPAR to update the division-level value (or delete it if tpidlbl is
  // an empty string).
  if tpidlbl <> lbledtDivPatIdLabel.Text then
  begin
    // use updstr to preserve possible empty string in tpidlbl.
    // use @ to signal to MUMPS to delete the division-level value.
    if tpidlbl = '' then
      updstr := '@'
    else
      updstr := tpidlbl;
    bres := SetParameter('PSB PATIENT ID LABEL', updstr);
    if bres then
      lbledtDivPatIdLabel.Text := tpidlbl;
  end;

  // run a final test with GETPAR ALL to verify what BCMA will see on its GETPAR
  lbledtAllPatIdLabel.Text := GetParameterLevel('PSB PATIENT ID LABEL', 'ALL',
    1);

end;

end.

